﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private splitMain As SplitPane
	Private splitRight As SplitPane
	Private lstViews As ListView
	Private txtUrl As TextField
	Private lstProperties As ListView
	Private lstHistory As ListView
	Private Tree As CLVTree
	Private CustomListView1 As CustomListView
	Private HTMLEditor1 As HTMLEditor
	Private TextArea1 As TextArea
	Private WebView1 As WebView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "Simple HTML Editor")
	splitMain.LoadLayout("LeftSide")
	splitMain.LoadLayout("Center")
	splitMain.LoadLayout("RightSide")
	'limit the widths of the two side layouts
	splitMain.SetSizeLimits(0, 0, 200)
	splitMain.SetSizeLimits(2, 0, 300)
	CreateRightSizeLayout
	LoadViewList
	GrowTree
	'lstViews.Items.AddAll(File.ReadList(File.DirAssets, "sites.txt"))
	'lstViews.SelectedIndex = 0
	
End Sub

Private Sub CreateRightSizeLayout
	splitRight.LoadLayout("RightProperties")
	splitRight.LoadLayout("RightMessageLog")
	'lstProperties.Items.Add("http://www.b4x.com")
End Sub

Private Sub btnDesigner_Click
	CustomListView1.AsView.Visible = True
	HTMLEditor1.Visible = False
	TextArea1.Visible = False
	WebView1.Visible = False
End Sub

Private Sub btnCode_Click
	CustomListView1.AsView.Visible = False
	HTMLEditor1.Visible = True
	TextArea1.Visible = True
	WebView1.Visible = False
	TextArea1.Text = HTMLEditor1.HtmlText
End Sub

Private Sub btnPreview_Click
	CustomListView1.AsView.Visible = False
	HTMLEditor1.Visible = False
	TextArea1.Visible = False
	WebView1.Visible = True
End Sub

Private Sub LoadViewList
	lstViews.Items.Add("<div>")
	lstViews.Items.Add("<p>")
	lstViews.Items.Add("<span>")
	lstViews.Items.Add("<form>")
	lstViews.Items.Add("<button>")
	lstViews.Items.Add($"<input type="text">"$)
	lstViews.Items.Add($"<input type="email">"$)
	lstViews.Items.Add($"<input type="password">"$)
	lstViews.Items.Add($"<input type="date">"$)
	lstViews.Items.Add("<select>")
End Sub

Private Sub GrowTree
	CustomListView1.DefaultTextBackgroundColor = xui.Color_White
	Tree.Initialize(CustomListView1)
	'logo = xui.LoadBitmap(File.DirAssets, "logo.png")
'	For i = 1 To 10
'		Dim item As CLVTreeItem = Tree.AddItem(Tree.Root, $"Item #${i}"$, Null, "")
'		For x = 1 To 5
'			Dim text As Object
'			#if B4J
'			text = $"${i}-${x}"$
'			#Else
'			Dim cs As CSBuilder
'			cs.Initialize.Color(xui.Color_Blue).Append(i).Pop.Append("-").Color(xui.Color_Red).Append(x).PopAll
'			text = cs
'			#End If
'			'Dim t As CLVTreeItem = Tree.AddItem(item, text, logo, "")
'			Dim t As CLVTreeItem = Tree.AddItem(item, text, Null, "")
'			Tree.CollapseItem(t)
'			If Rnd(1, 8) = 6 Then
'				For y = 1 To 5
'					Tree.AddItem(t, $"${i}-${x}-${y}"$, Null, "")
'				Next
'			End If
'		Next
'	Next
	
	
	Dim html As CLVTreeItem = Tree.AddItem(Tree.Root, $"<html>"$, Null, "")
	Dim head As CLVTreeItem = Tree.AddItem(html, "<head>", Null, "head")
	Dim meta1 As CLVTreeItem = Tree.AddItem(head, $"<meta charset="utf-8">"$, Null, "meta1")
	Dim meta2 As CLVTreeItem = Tree.AddItem(head, $"<meta name="viewport" content="width=device-width, initial-scale=1">"$, Null, "meta2")
	Dim title As CLVTreeItem = Tree.AddItem(head, "<title>Demo Website", Null, "title")
	Tree.CollapseItem(head)
	Dim body As CLVTreeItem = Tree.AddItem(html, "<body>", Null, "body")
	Dim h1_001 As CLVTreeItem = Tree.AddItem(body, "<h1>Hello World!", Null, "h1_001")
	Dim div_0001 As CLVTreeItem = Tree.AddItem(body, $"<div class="col-md-6">"$, Null, "div_0001")
	Dim form_001 As CLVTreeItem = Tree.AddItem(div_0001, $"<form id="form1" class="login">"$, Null, "form_001")
	
	Dim div_0003 As CLVTreeItem = Tree.AddItem(form_001, $"<div class="mb-3">"$, Null, "div_0003")
	
	Dim label_001 As CLVTreeItem = Tree.AddItem(div_0003, $"<label for="email" class="form-label">Email address"$, Null, "label_001")
	Dim input_001 As CLVTreeItem = Tree.AddItem(div_0003, $"<input type="email" id="email" class="form-control">"$, Null, "input_001")
	Dim button_001 As CLVTreeItem = Tree.AddItem(form_001, $"<button type="submit" id="send" class="btn btn-primary">Submit"$, Null, "button_001")
	
	Dim div_0002 As CLVTreeItem = Tree.AddItem(body, $"<div class="col-md-6">"$, Null, "div_0002")
	Tree.CollapseItem(body)
End Sub

Sub lstViews_SelectedIndexChanged(Index As Int)
	If Index = -1 Then Return
	'txtUrl.Text = $"http://www.${lstViews.Items.Get(Index)}"$
	txtUrl.Text = lstViews.Items.Get(Index)
	btnGo_Action
End Sub

Sub txtUrl_Action
	btnGo_Action
End Sub

Sub btnGo_Action
	txtUrl.Text = txtUrl.Text.Trim
	If txtUrl.Text.Length = 0 Then Return
	'If txtUrl.Text.StartsWith("http") = False Then txtUrl.Text = "http://" & txtUrl.Text
	Dim currentIndex As Int = lstHistory.Items.IndexOf(txtUrl.Text)
	If currentIndex > -1 Then lstHistory.Items.RemoveAt(currentIndex)
	lstHistory.Items.InsertAt(0, txtUrl.Text)
	WebView1.LoadUrl(txtUrl.Text)
End Sub

Private Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Tree.CLV_VisibleRangeChanged(FirstIndex, LastIndex)
End Sub

Private Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	Dim item As CLVTreeItem = Value
	Log(item.Text)
	'Tree.AddItem(item, $"new item - $Time{DateTime.Now}"$, logo, "")
	'Tree.AddItem(item, $"new item - $Time{DateTime.Now}"$, Null, "")
	'Tree.ExpandItem(item)
End Sub

Sub WebView1_PageFinished (Url As String)
	txtUrl.Text = Url
End Sub

Sub lstHistory_SelectedIndexChanged(Index As Int)
	If Index = -1 Then Return
	txtUrl.Text = lstHistory.Items.Get(Index)
	lstHistory.SelectedIndex = -1
	btnGo_Action
End Sub

Sub lstProperties_SelectedIndexChanged(Index As Int)
	If Index = -1 Then Return
	lstProperties.SelectedIndex = -1
	txtUrl.Text = lstProperties.Items.Get(Index)
	btnGo_Action
End Sub

Private Sub btnCollapseAll_Click
	Tree.CollapseAll
End Sub

Private Sub btnExpandAll_Click
	Tree.ExpandAll
End Sub